var redis = require('redis'),
    minimatch = require('minimatch'),
    includeRe,
    excludeRe;

function matchFilters(subject) {
    for (var x = 0, len = exclude.length; x < len; x++) {
        minimatch.match(subject, )
        return false;
    }

    if (minimatch.match(include, subject, {matchBase: true})) {
        console.log('#2');
        return true;
    }

    console.log('#3');
}

module.exports = {
    init: function (config, eventEmitter) {
        console.log('Connecting to redis on: ' + config.host || '127.0.0.1');

        client = redis.createClient(config);

        client.on('connect', function() {
            console.log('Connected to redis!');

            eventEmitter.on('event', function (event) {
                var subject;

                console.log(subject);

                if (event.schema && event.table && event.pk) {
                    subject = event.schema + '.' + event.table + (event.pk ? ('.' + event.pk) : '');
                } else if (event.ns && event.pk) {
                    subject = event.ns + '.' + event.pk;
                } else {
                    return;
                }

                console.log(subject);


                if (matchFilters(subject)) {
                    if (event.action == 'delete') {
                        console.log('delete', subject);
                        client.del(subject, redis.print);
                    } else {
                        console.log('set', subject);
                        client.set(subject, JSON.stringify(event.item), redis.print);
                    }
                }
            });
        });
    },

    validateConfig: function (config, scopeConfig, globalConfig) {
        var errors = [];

        if (Array.isArray(config.include)) {
            includeRe = minimatch.makeRe(config.include);
        }

        if (Array.isArray(config.exclude)) {
           exclude = config.exclude;
        }

        return errors;
    }
};